//+------------------------------------------------------------------+
//|                                                         SMAs.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "http://candid.110mb.com/"

//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_width1 2

extern int SMANumber = 1000;
extern int sh = 0;
extern int hf = 4;

int PreBars;
datetime BarTime;
int MinBars;
int StartPos;
int pos;

//int sh;
int i;

double Sum;
double SMA[];

double D[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  MinBars = SMANumber+1;

  SetIndexBuffer(0,D);
  SetIndexStyle(0,DRAW_LINE,EMPTY,2);
  SetIndexEmptyValue(0,0.0);

  ArrayResize(SMA,SMANumber+1);
//---- indicators
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//----
   
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  PreBars = 0;
  BarTime = 0;
  return(Bars-MinBars);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
//      
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Alert(":    ");
    return(0);
  }  
//      1    ""
//   
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
//       
  else StartPos = Reset();
//   
  PreBars = Bars;  
  BarTime=Time[0];
//----

  StartPos = 1;
  for (pos=StartPos;pos>0;pos--) {
    Sum = Close[sh+1];
    SMA[1] = Sum;
    for (i = 2;i<=SMANumber;i++) {
      Sum += Close[sh+i];
      SMA[i] = Sum/i;
    }
    ArraySort(SMA);
    for (i = hf+1;i<=SMANumber-hf;i++) {
      D[sh+i] = SMA[i+hf] - SMA[i-hf];
    }
  }  //  pos=StartPos;pos>0;pos--) 
//----
  return(0);
}
//+------------------------------------------------------------------+